/*
 * uData API
 * uData API
 *
 * OpenAPI spec version: 1.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.asso.ladoxa.datagouv.models;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * GeoLevel
 */

public class GeoLevel {
  @JsonProperty("id")
  private String id = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("parents")
  private List<String> parents = null;

  public GeoLevel id(String id) {
    this.id = id;
    return this;
  }

   /**
   * The level identifier
   * @return id
  **/
  @ApiModelProperty(required = true, value = "The level identifier")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public GeoLevel name(String name) {
    this.name = name;
    return this;
  }

   /**
   * The level name
   * @return name
  **/
  @ApiModelProperty(required = true, value = "The level name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public GeoLevel parents(List<String> parents) {
    this.parents = parents;
    return this;
  }

  public GeoLevel addParentsItem(String parentsItem) {
    if (this.parents == null) {
      this.parents = new ArrayList<String>();
    }
    this.parents.add(parentsItem);
    return this;
  }

   /**
   * The parent levels
   * @return parents
  **/
  @ApiModelProperty(value = "The parent levels")
  public List<String> getParents() {
    return parents;
  }

  public void setParents(List<String> parents) {
    this.parents = parents;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    GeoLevel geoLevel = (GeoLevel) o;
    return Objects.equals(this.id, geoLevel.id) &&
        Objects.equals(this.name, geoLevel.name) &&
        Objects.equals(this.parents, geoLevel.parents);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, parents);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class GeoLevel {\n");

    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    parents: ").append(toIndentedString(parents)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

